/* -*- C -*-
 *
 * Copyright 2011 Sandia Corporation. Under the terms of Contract
 * DE-AC04-94AL85000 with Sandia Corporation, the U.S.  Government
 * retains certain rights in this software.
 *
 * Copyright (c) 2015 Intel Corporation. All rights reserved.
 * This software is available to you under the BSD license.
 *
 * This file is part of the Sandia OpenSHMEM software package. For license
 * information, see the LICENSE file in the top level directory of the
 * distribution.
 *
 */

#ifndef SHMEMX_H
#define SHMEMX_H

#include <stddef.h>

#define SHMEMX_THREAD_SINGLE     0
#define SHMEMX_THREAD_FUNNELED   1
#define SHMEMX_THREAD_SERIALIZED 2
#define SHMEMX_THREAD_MULTIPLE   3

#define HAVE_SHMEMX_WTIME

void shmemx_init_thread(int tl_requested, int *tl_provided);
double shmemx_wtime(void);
char* shmemx_nodename(void);

/* Counting puts */
typedef char * shmemx_ct_t;

void shmemx_getmem_ct(shmemx_ct_t ct, void *target, const void *source, size_t len, int pe);
void shmemx_putmem_ct(shmemx_ct_t ct, void *target, const void *source, size_t len, int pe);
void shmemx_ct_create(shmemx_ct_t *ct);
void shmemx_ct_free(shmemx_ct_t *ct);
long shmemx_ct_get(shmemx_ct_t ct);
void shmemx_ct_set(shmemx_ct_t ct, long value);
void shmemx_ct_wait(shmemx_ct_t ct, long wait_for);

#endif /* SHMEMX_H */
